import type {
  WorkflowVersionReduced,
  WorkflowVersionFull,
} from "@/client/workflow";
import dayjs from "dayjs";

export function sortedVersions(
  versions: WorkflowVersionFull[]
): WorkflowVersionFull[];
export function sortedVersions(
  versions: WorkflowVersionReduced[]
): WorkflowVersionReduced[];

// eslint-disable-next-line @typescript-eslint/no-explicit-any
export function sortedVersions(versions: any[], desc = true): any[] {
  const vs = [...versions];
  if (desc) {
    vs.sort((a, b) => (dayjs(a.created_at).isBefore(b.created_at) ? 1 : -1));
  } else {
    vs.sort((a, b) => (dayjs(a.created_at).isBefore(b.created_at) ? -1 : 1));
  }
  return vs;
}

export function latestVersion(
  versions: WorkflowVersionFull[]
): WorkflowVersionFull | undefined;

export function latestVersion(
  versions: WorkflowVersionReduced[]
): WorkflowVersionReduced | undefined;

// eslint-disable-next-line @typescript-eslint/no-explicit-any
export function latestVersion(versions: any[]): any | undefined {
  if (versions == undefined || versions.length == 0) {
    return undefined;
  }
  const vs = sortedVersions(versions);
  return vs[0];
}
